import numpy as np
# Matrix A and b
A=np.array([[ 9.0,-2.0, 1.0, 0.0],
            [-1.0,10.0,-2.0, 4.0],
            [ 3.0,-2.0, 9.0,-1.0],
            [ 0.0, 4.0,-2.0, 7.0]])      
b=np.array([13.0,-23.0,-10.0,-1.0]).T

# Gauss-Seidel
x0     =np.array([0.5,0.5,0.5,0.5]).T
xk,xkp1=np.zeros_like(x0),np.zeros_like(x0)
for i in range(0,4):
    xk  [i]=x0[i]
    xkp1[i]=xk[i]

iter=0
eps=1e-8
while True:
    for i in range(0,4):
        sum=0
        for j in range(0,4):
            if j<i:
                sum=sum+A[i][j]*xkp1[j]
            elif j>i:
                sum=sum+A[i][j]*xk  [j]
        xkp1[i]=(b[i]-sum)/A[i][i]
        
    if np.linalg.norm(xkp1-xk)<eps:          
        print("Gauss-Seidel iteration converges at iter=",iter)
        print("x=",xkp1)
        break
    
    for i in range(0,4):
        xk[i]=xkp1[i]
    
    iter=iter+1   