import numpy as np
import matplotlib.pyplot as plt

# Given data
x=np.array([1,2,3,4,5])
y=np.array([1,3,5,3,7])

N=len(x)

# PCA
# 1. Compute the mean mu=(mu_x,mu_y)
mu_x=np.mean(x)
mu_y=np.mean(y)

# 2. Compute the Covariance matrix Sigma
x_tilde, y_tilde=x-mu_x,y-mu_y
X_tilde=np.row_stack((x_tilde.T,y_tilde.T))

Sigma=np.dot(X_tilde,X_tilde.T)/N

# 3. Eigendecomposition of Sigma
lambdas, qs=np.linalg.eig(Sigma)

# Make first component of eigenvector to be positive
for i in range(0,2):
    if qs[i][0]<0:
        qs[i][0]=-qs[i][0]
        qs[i][1]=-qs[i][1]

print("lambda1: ",lambdas[0],",q1: ",qs[0])
print("lambda2: ",lambdas[1],",q2: ",qs[1])
        
# Visualization
v1 = qs[0]
v2 = qs[1]

plt.arrow(mu_x,mu_y,v1[0],v1[1])
plt.arrow(mu_x,mu_y,v2[0],v2[1])
plt.scatter(x,y)
plt.axis('equal')
plt.show()
